/*
LinkedListBigOAnswers.java

RULES:

	1. Replace all tags "YOURANSWER" below with your big-o guess for the given method

	2. The method name pattern in this class is:

		Method in this class: "size_BigO"
		Associated method in LinkedList: "size"

	3. Do Big-O analysis for the subject method (e.g. like "size" in previous step)

	4. Replace "YOURANSWER" with your best big-o analysis guess (either "1" or "n")

	5. Problems have been done for you to help you get started. See methods in this file:

		size_BigO
		isEmpty_BigO
		subList_BigO

	6. To be safe, assume worst-case for your analysis (e.g. for a
	linear search or find, that means the match would be in the
	last list element).

	7. You do NOT need to add comments to your methods. You only need to provide
	a big-o guess (in other words, replace "YOURANSWER" with either "1" or "n").

*/

public class LinkedListBigOAnswers {

	//-------------------- Basic Statistics ---------------------

	public String size_BigO() {
		/* We will assume (for Big-O) we have an optimization of keeping track
		of size as an ivar. So, given size is an ivar, then there is only
		one operation (getting 'this.size"). We are NOT dependent on the
		size of linked list or "n".
		Thus we have O(1)*/
		return "1";
	}

	public String isEmpty_BigO() {
		/*"isEmpty" can be derived without being dependent on "n".
		Because "size" (above) is O(1), our algo could use "size".
		Even simpler, we could just return true if firstNode is null.
		Either algorithm would result in O(1), so we return "1"*/
		return "1";
	}

	//--------------------- Accessing ---------------------

	public String get_BigO(int index) {
		return "YOURANSWER";
	}

	public String subList_BigO(int start, int stop) {
		/* The method input params could be "n".
		And we need to iterate to find the positions, and also
		to compose the subList. Thus this method requires iteration that
		is dependent on "n", so Big-O is O(n).
		So we return "n" as our big-O guess*/
		return "n";
	}

	public String first_BigO() {
		return "YOURANSWER";
	}

	public String last_BigO() {
		return "YOURANSWER";
	}

	public String find_BigO() {
		//Hint: this is a linear search
		return "YOURANSWER";
	}

	//--------------------- Adding ---------------------

	public String addFirst_BigO() {
		return "YOURANSWER";
	}

	public String addLast_BigO() {
		return "YOURANSWER";
	}

	public String add_BigO() {
		return "YOURANSWER";
	}

	public String insert_BigO() {
		return "YOURANSWER";
	}

	//--------------------- Removing ---------------------

	public String removeFirst_BigO() {
		return "YOURANSWER";
	}

	public String removeLast_BigO() {
		return "YOURANSWER";
	}

	public String removeAll_BigO() {
		return "YOURANSWER";
	}

	public String removeIndex_BigO() {
		return "YOURANSWER";
	}

	public String remove_BigO() {
		return "YOURANSWER";
	}

	//--------------------- Convenience ---------------------

	public String toJavaList_BigO() {
		return "YOURANSWER";
	}

}
